diff --git a/tests/fate-run.sh b/tests/fate-run.sh
index 1111cff..c640cc5 100755
--- a/tests/fate-run.sh
+++ b/tests/fate-run.sh
@@ -197,6 +197,7 @@ transcode(){
     srcfile=$2
     enc_fmt=$3
     enc_opt=$4
+    final_decode=$5
     encfile="${outdir}/${test}.${enc_fmt}"
     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
     tsrcfile=$(target_path $srcfile)
@@ -205,7 +206,7 @@ transcode(){
         -f $enc_fmt -y $tencfile || return
     do_md5sum $encfile
     echo $(wc -c $encfile)
-    ffmpeg $DEC_OPTS -i $encfile $ENC_OPTS $FLAGS \
+    ffmpeg $DEC_OPTS -i $encfile $ENC_OPTS $FLAGS $final_decode \
         -f framecrc - || return
 }
 
diff --git a/tests/fate/ffmpeg.mak b/tests/fate/ffmpeg.mak
index 42f0776..3782f82 100644
--- a/tests/fate/ffmpeg.mak
+++ b/tests/fate/ffmpeg.mak
@@ -84,5 +84,10 @@ fate-rgb24-mkv: $(TARGET_SAMPLES)/qtrle/aletrek-rle.mov
 fate-rgb24-mkv: CMD = transcode "mov" $(TARGET_SAMPLES)/qtrle/aletrek-rle.mov\
                       matroska "-vcodec rawvideo -pix_fmt rgb24 -allow_raw_vfw 1 -vframes 1"
 
+FATE_SAMPLES_FFMPEG-$(call ALLYES, AAC_DEMUXER MOV_MUXER) += fate-adtstoasc_ticket3715
+fate-adtstoasc_ticket3715: $(TARGET_SAMPLES)/aac/foo.aac
+fate-adtstoasc_ticket3715: CMD = transcode "aac" $(TARGET_SAMPLES)/aac/foo.aac\
+                      mov "-c copy -bsf:a aac_adtstoasc" "-codec copy"
+
 
 FATE_SAMPLES_FFMPEG-yes += $(FATE_STREAMCOPY-yes)
diff --git a/tests/ref/fate/adtstoasc_ticket3715 b/tests/ref/fate/adtstoasc_ticket3715
new file mode 100644
index 0000000..ff8e8ab
--- /dev/null
+++ b/tests/ref/fate/adtstoasc_ticket3715
@@ -0,0 +1,94 @@
+ef8ce3cbd1d86113e7c991a816086068 *tests/data/fate/adtstoasc_ticket3715.mov
+33270 tests/data/fate/adtstoasc_ticket3715.mov
+#extradata 0:        2, 0x00340022
+#tb 0: 1/44100
+#media_type 0: audio
+#codec_id 0: aac
+#sample_rate 0: 44100
+#channel_layout 0: 3
+0,          0,          0,     1024,      371, 0x14b11a4f
+0,       1024,       1024,     1024,      402, 0x2f00c487
+0,       2048,       2048,     1024,      403, 0x1959c0d4
+0,       3072,       3072,     1024,      396, 0x98a9c134
+0,       4096,       4096,     1024,      405, 0xf0a5c8c7
+0,       5120,       5120,     1024,      432, 0xefaed68f
+0,       6144,       6144,     1024,      369, 0x41e4bc81
+0,       7168,       7168,     1024,      370, 0x0052ba67
+0,       8192,       8192,     1024,      426, 0x9b61d389
+0,       9216,       9216,     1024,      346, 0xf24aacf8
+0,      10240,      10240,     1024,      361, 0x815aa4b9
+0,      11264,      11264,     1024,      370, 0xad0db010
+0,      12288,      12288,     1024,      370, 0x6e27bdca
+0,      13312,      13312,     1024,      358, 0x973caed2
+0,      14336,      14336,     1024,      362, 0x8c57b25c
+0,      15360,      15360,     1024,      359, 0x8c6ab063
+0,      16384,      16384,     1024,      373, 0x7838b78f
+0,      17408,      17408,     1024,      489, 0x8fc2f7f0
+0,      18432,      18432,     1024,      346, 0x4ac8b6f8
+0,      19456,      19456,     1024,      341, 0xb537abef
+0,      20480,      20480,     1024,      352, 0xcc43b761
+0,      21504,      21504,     1024,      355, 0xb1b2b234
+0,      22528,      22528,     1024,      354, 0xa865a68c
+0,      23552,      23552,     1024,      370, 0xcad4ace5
+0,      24576,      24576,     1024,      369, 0x4911addc
+0,      25600,      25600,     1024,      363, 0x5a14a836
+0,      26624,      26624,     1024,      361, 0x6d10b6ba
+0,      27648,      27648,     1024,      365, 0xfe1bb5f3
+0,      28672,      28672,     1024,      362, 0x6fc5b252
+0,      29696,      29696,     1024,      366, 0xa122b655
+0,      30720,      30720,     1024,      371, 0xd338ae3d
+0,      31744,      31744,     1024,      363, 0xd977ad97
+0,      32768,      32768,     1024,      384, 0xe443bcc4
+0,      33792,      33792,     1024,      374, 0x281bb8cb
+0,      34816,      34816,     1024,      387, 0x2d70bfef
+0,      35840,      35840,     1024,      363, 0xa6e1b7a6
+0,      36864,      36864,     1024,      387, 0xc5d5c62b
+0,      37888,      37888,     1024,      378, 0xdf71c12f
+0,      38912,      38912,     1024,      377, 0xba9fbead
+0,      39936,      39936,     1024,      359, 0x4495babf
+0,      40960,      40960,     1024,      373, 0x6fbeb8ad
+0,      41984,      41984,     1024,      446, 0x3f98e19a
+0,      43008,      43008,     1024,      348, 0x7aa8b3d0
+0,      44032,      44032,     1024,      355, 0x3cf9abde
+0,      45056,      45056,     1024,      360, 0x3b93aa3d
+0,      46080,      46080,     1024,      411, 0x4534cd86
+0,      47104,      47104,     1024,      402, 0xf215cc44
+0,      48128,      48128,     1024,      483, 0xcf47f39e
+0,      49152,      49152,     1024,      343, 0xcbdeaf99
+0,      50176,      50176,     1024,      343, 0x8444aa2b
+0,      51200,      51200,     1024,      343, 0x5a46a569
+0,      52224,      52224,     1024,      345, 0x3b03a951
+0,      53248,      53248,     1024,      346, 0xff43a665
+0,      54272,      54272,     1024,      355, 0xedb1ac99
+0,      55296,      55296,     1024,      368, 0xb09cb70f
+0,      56320,      56320,     1024,      437, 0xfdd5ea5e
+0,      57344,      57344,     1024,      334, 0x8c35a4b9
+0,      58368,      58368,     1024,      395, 0xb777c61b
+0,      59392,      59392,     1024,      372, 0xafacb084
+0,      60416,      60416,     1024,      350, 0x1ab0a8c8
+0,      61440,      61440,     1024,      342, 0xb6e1a569
+0,      62464,      62464,     1024,      351, 0x583ba6f8
+0,      63488,      63488,     1024,      360, 0xc72ba9a4
+0,      64512,      64512,     1024,      360, 0xb30bae66
+0,      65536,      65536,     1024,      385, 0x4c38bd75
+0,      66560,      66560,     1024,      471, 0xd47df0d5
+0,      67584,      67584,     1024,      339, 0x9bf1a445
+0,      68608,      68608,     1024,      354, 0xf336b051
+0,      69632,      69632,     1024,      348, 0x6d06af84
+0,      70656,      70656,     1024,      355, 0xa4e1acf7
+0,      71680,      71680,     1024,      348, 0xcd0eac56
+0,      72704,      72704,     1024,      395, 0xb298c18b
+0,      73728,      73728,     1024,      427, 0x3dc9dcc0
+0,      74752,      74752,     1024,      344, 0x01c8ae69
+0,      75776,      75776,     1024,      356, 0xc38ca6f8
+0,      76800,      76800,     1024,      372, 0xd35db793
+0,      77824,      77824,     1024,      371, 0xd4cabb37
+0,      78848,      78848,     1024,      371, 0x69c3ac44
+0,      79872,      79872,     1024,      365, 0xe9cfb1ce
+0,      80896,      80896,     1024,      369, 0xb977bbc6
+0,      81920,      81920,     1024,      416, 0xa04fd851
+0,      82944,      82944,     1024,      461, 0x0c36eb7b
+0,      83968,      83968,     1024,      465, 0xeb3ce0af
+0,      84992,      84992,     1024,      326, 0x7be4a667
+0,      86016,      86016,     1024,      339, 0x2cf4a71f
+0,      87040,      87040,     1028,      258, 0xd4007ad4